Index: if_smsc.c
===================================================================
--- if_smsc.c	(revision 246066)
+++ if_smsc.c	(working copy)
@@ -948,6 +948,7 @@
 	struct usb_ether *ue = &sc->sc_ue;
 	struct ifnet *ifp = uether_getifp(ue);
 	struct mbuf *m;
+	struct ether_header *eh;
 	struct usb_page_cache *pc;
 	uint32_t rxhdr;
 	uint16_t pktlen;
@@ -1006,6 +1007,7 @@
 				}
 				
 				usbd_copy_out(pc, off, mtod(m, uint8_t *), pktlen);
+				eh = mtod(m, struct ether_header *);
 
 				/* Check if RX TCP/UDP checksumming is being offloaded */
 				if ((ifp->if_capenable & IFCAP_RXCSUM) != 0) {
@@ -1021,7 +1023,7 @@
 					 * ignore the H/W csum on frames less than or equal to
 					 * 64 bytes.
 					 */
-					if (pktlen > ETHER_MIN_LEN) {
+					if (be16toh(eh->ether_type) == ETHERTYPE_IP && pktlen > ETHER_MIN_LEN) {
 					
 						/* Indicate the UDP/TCP csum has been calculated */
 						m->m_pkthdr.csum_flags |= CSUM_DATA_VALID;
